;; A few programs relating to binomial coefficients

;;           ( m )
;; Calculate |   | (the binomial coefficient)
;;           ( n )

(in-package '*lisp)  ;; For use with parallel programs

(defun binom(m n)
  (declare (type fixnum m n))
  (let ((c 1) (d (- m n)))
       (declare (type fixnum c d))
     (if (> n d) (setq n d))
     (setq d 1)
     (dotimes (k n)
       (setq c (truncate (* c m) d))
       (incf d) (decf m)
     ) ;; end dotimes
     c) ;; end let
) ;; end binom

;;               n
;; (Sets m n) = SUM (binom m k)
;;              k=0
;;
;; which is the number of sets of at most n out of m objects

(defun Sets(m n)
  (declare (type fixnum m n))
  (let ((c 1) (d (- m n)) (s 1))
       (declare (type fixnum c d s))
     (setq d 1)
     (dotimes (k n)
       (setq c (truncate (* c m) d))
       (incf s c)
       (incf d) (decf m)
      ) ;; end dotimes
      s) ;; end let
) ;; end Sets
